package com.mh;

import java.io.*;
import java.util.Enumeration;

import javax.microedition.io.Connector;
import javax.microedition.rms.RecordStore;

import com.siemens.mp.io.file.*;
import javax.microedition.rms.RecordStoreException;

/**
 * <p>Title: Mh Media Envirnoment</p>
 *
 * <p>Description: New Mh Media Product</p>
 *
 * <p>Copyright: Mh Copyright (c) 2005-2007</p>
 *
 * <p>Company: Mh Xorp <WAS></p>
 *
 * @author Mihard
 * @version null
 */
public class mfw {
    public static int NO_FILTER = 0;
    public static int ALL_ACSEPT = 578;
    public static int NO_DIRS = 58;
    public static int AUDIO_FORMATS = 123;
    public static int VIDEO_FORMATS = 265;
    public static int TEXT_FORMATS = 487;
    public static int PLL_FORMATS = 666;

    public static int SKIN_FORMATS = 661;
    public static int FONT_FORMATS = 662;
    public static int LNG_FORMATS = 663;
    public mfw() {
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }

    }

    public static void mkDir(String pth, String name) throws IOException {
        FileConnection fc = (FileConnection) Connector.open("file:///" + pth, 3);
        fc.setWritable(true);
        fc.close();
        fc = null;

        fc = (FileConnection) Connector.open("file:///" + pth +
                                             "/" + name, 3);
        System.out.println(fc.getURL());
        if (fc.exists()) {
            fc.delete();
        }

        fc.mkdir();
        fc.close();
        fc = null;
    }


    public static String[] loadRMS(String name) throws Exception {
        RecordStore trs = RecordStore.openRecordStore(name, true);
        String[] ret = new String[0];
        if (trs.getNumRecords() > 0) {
            ByteArrayInputStream bais = new ByteArrayInputStream(trs.getRecord(
                    1));
            DataInputStream dis = new DataInputStream(bais);
            int lgh = dis.readInt();
            ret = new String[lgh];
            for (int i = 0; i < ret.length; i++) {
                ret[i] = dis.readUTF();
            }
        } else {
            throw new Exception("Empty RMS");
        }
        trs.closeRecordStore();
        return ret;
    }

    public static byte[] loadDataRMS(String name) throws Exception {
        RecordStore trs = RecordStore.openRecordStore(name, true);
        byte[] ret = new byte[0];
        if (trs.getNumRecords() > 1) {
            ret = trs.getRecord(2);
        }

        trs.closeRecordStore();
        return ret;
    }

    public static void collaps() {
        String[] t = RecordStore.listRecordStores();
        for (int i = 0; i < t.length; i++) {
            try {
                RecordStore.deleteRecordStore(t[i]);
            } catch (RecordStoreException ex) {
            }
        }
    }

    public static String[] loadPLLS(int type) throws Exception {
        RecordStore trs = RecordStore.openRecordStore("plls", true);
        String[] ret = new String[0];
        if (trs.getNumRecords() >= type - 6600) {
            System.out.println(trs.getNumRecords());
            System.out.println("PLLS id = " + (type - 6600));
            ByteArrayInputStream bais = new ByteArrayInputStream(trs.getRecord(
                    type - 6600));
            DataInputStream dis = new DataInputStream(bais);
            int lgh = dis.readInt();
            ret = new String[lgh];
            for (int i = 0; i < ret.length; i++) {
                ret[i] = dis.readUTF();
            }
        } else {
            throw new Exception("Empty PLLS ");
        }

        trs.closeRecordStore();
        return ret;
    }

    public static String[] loadPLL(int type, String name) throws Exception {
        RecordStore trs = RecordStore.openRecordStore("pll_" + type + "_" +
                name, true);
        String[] ret = new String[0];
        if (trs.getNumRecords() > 0) {
            System.out.println(trs.getNumRecords());
            ByteArrayInputStream bais = new ByteArrayInputStream(trs.getRecord(
                    1));
            DataInputStream dis = new DataInputStream(bais);
            int lgh = dis.readInt();
            ret = new String[lgh];
            for (int i = 0; i < ret.length; i++) {
                ret[i] = dis.readUTF();
            }
        } else {
            throw new Exception("Empty PLL");
        }

        trs.closeRecordStore();
        return ret;
    }

    public static void saveRMS(String name, String[] list) throws Exception {
        RecordStore trs = RecordStore.openRecordStore(name, true);
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(baos);
        dos.writeInt(list.length);
        for (int i = 0; i < list.length; i++) {
            dos.writeUTF(list[i]);
        }
        if (trs.getNumRecords() > 0) {
            trs.setRecord(1, baos.toByteArray(), 0, baos.size());
        } else {
            System.out.println(trs.addRecord(baos.toByteArray(), 0, baos.size()));
        }
        trs.closeRecordStore();
    }

    public static void saveDataRMS(String name, byte[] data) throws Exception {
        RecordStore trs = RecordStore.openRecordStore(name, true);
        if (trs.getNumRecords() > 1) {
            trs.setRecord(2, data, 0, data.length);
        } else {
            System.out.println(trs.addRecord(data, 0, data.length));
        }
        trs.closeRecordStore();
    }

    public static void savePLLS(int type, String[] list) throws Exception {
        RecordStore trs = RecordStore.openRecordStore("plls", true);
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(baos);
        dos.writeInt(list.length);
        for (int i = 0; i < list.length; i++) {
            dos.writeUTF(list[i]);
        }
        if (trs.getNumRecords() >= type - 6600) {
            trs.setRecord(type - 6600, baos.toByteArray(), 0, baos.size());
        } else {
            System.out.println(trs.addRecord(baos.toByteArray(), 0, baos.size()));
        }
        trs.closeRecordStore();
    }

    public static void savePLL(int type, String name, String[] list) throws
            Exception {
        RecordStore trs = RecordStore.openRecordStore("pll_" + type + "_" +
                name, true);
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(baos);
        dos.writeInt(list.length);
        for (int i = 0; i < list.length; i++) {
            dos.writeUTF(list[i]);
        }
        if (trs.getNumRecords() >= 1) {
            trs.setRecord(1, baos.toByteArray(), 0, baos.size());
        } else {
            System.out.println(trs.addRecord(baos.toByteArray(), 0, baos.size()));
        }
        trs.closeRecordStore();
    }

    public static void delPLL(int type, String name) throws Exception {
        delRMS("pll_" + type + "_" + name);
    }

    public static void delRMS(String name) throws Exception {
        RecordStore.deleteRecordStore(name);
    }

    public static boolean isDir(String fn) throws IOException {
        FileConnection conn = null;
        conn = (FileConnection) Connector.open("file:///" + fn, 3);
        /*try {
            conn = (FileConnection) Connector.open("file:///" + fn, 1);
            conn.list();
            return true;
                 } catch (IOException ex) {*/
        if (conn.isDirectory()) {
            return true;
        } else {
            return false;
        }
        //}

    }

    public static boolean FileExist(String fn) throws IOException {
        FileConnection fc = (FileConnection) Connector.open("file:///" + fn, 3);
        return fc.exists();
    }

    public static void saveUTFFile(String fn, String[] text) throws IOException {
        FileConnection fc = (FileConnection) Connector.open("file:///" + fn, 3);

        if (fc.exists()) {

            fc.delete();

        } else {

        }
        fc.create();
        System.out.println("file created");
        DataOutputStream dos = fc.openDataOutputStream();
        System.out.println("dos opened");
        dos.writeInt(text.length);
        System.out.println("length writed");
        for (int i = 0; i < text.length; i++) {
            System.out.println("text[" + i + "] = " + text[i] + " writed");
            dos.writeUTF(text[i]);
        }
        dos.flush();
        System.out.println("dos flushed");
        dos.close();
        System.out.println("dos closed");
        fc.close();
        System.out.println("fc closed");

    }


    public static String[] openUTFFile(String fn) throws IOException,
            NullPointerException {
        String[] strr = new String[0];
        FileConnection fc = (FileConnection) Connector.open("file:///" + fn, 3);
        byte[] bf = null;
        if (fc.exists()) {
            int fl = (int) fc.fileSize();
            DataInputStream dis = fc.openDataInputStream();
            int lgh = dis.readInt();
            strr = new String[lgh];

            for (int i = 0; i < strr.length; i++) {
                strr[i] = dis.readUTF();
            }
            dis.close();
        } else {
            throw new IOException("not found");
        }

        fc.close();
        return strr;
    }

    public static byte[] openDataFile(String fn) throws IOException,
            NullPointerException {
        FileConnection fc = (FileConnection) Connector.open("file:///" + fn, 3);
        byte[] bf = null;
        if (fc.exists()) {
            int fl = (int) fc.fileSize();
            DataInputStream dis = fc.openDataInputStream();
            bf = new byte[fl];
            dis.read(bf);
            dis.close();
        } else {
            throw new IOException("not found");
        }
        fc.close();
        return bf;
    }

    public static void saveDataFile(String fn, byte[] data) throws IOException {
        FileConnection fc = (FileConnection) Connector.open("file:///" + fn, 3);
        if (fc.exists()) {
            fc.delete();
        }
        fc.create();
        DataOutputStream dos = fc.openDataOutputStream();
        dos.write(data, 0, data.length);
        dos.flush();
        dos.close();
        fc.close();
    }

    public static void delFile(String name) {
        try {

            FileConnection fc = (FileConnection) Connector.open("file:///" +
                    name,
                    3);
            if (fc.exists()) {
                fc.delete();
            }
            fc.close();
        } catch (IOException ex) {
        }
    }

    public static void copyFile(String name, String name2) {
        byte[] bf = null;
        try {
            bf = openDataFile(name);
            saveDataFile(name2, bf);
        } catch (NullPointerException ex) {
        } catch (IOException ex) {
        }
    }

    public static String[] loadRoots() {
        Enumeration en = FileSystemRegistry.listRoots();
        String[] temp = new String[201];
        int i = 0;
        while (en.hasMoreElements()) {
            try {
                FileConnection fc = (FileConnection) Connector.open("file:///" +
                        ((String) en.nextElement()));
                Enumeration en1 = fc.list();

                while (en1.hasMoreElements()) {
                    temp[i] = fc.getPath().substring(1) +
                              (String) en1.nextElement();
                    i++;
                }

            } catch (IOException ex) {
            }

        }
        String[] t2 = new String[i];
        for (int j = 0; j < t2.length; j++) {
            t2[j] = temp[j].substring(0, temp[j].lastIndexOf('/'));
            System.out.println(t2[j]);
        }
        temp = null;
        return t2;
    }

    public static boolean DirCreate(String fn) {
        FileConnection fc = null;
        try {
            fc = (FileConnection) Connector.open("file://" + fn);
        } catch (IOException ex1) {
            System.out.println("ex0:"+ex1);
        }
        if (!fc.exists()) {
            try {
                fc.create();
                fc.mkdir();
            } catch (Exception ex) {
                System.out.println("ex:"+ex);
               String p;
               while (!DirCreate(fn)) {
                   p = fn.substring(0,fn.substring(0, fn.length() - 2).lastIndexOf('/') - 1);
                   System.out.println("p:"+p);
                    while (!DirCreate(p)) {
                        p = fn.substring(0,p.substring(0, p.length() - 2).lastIndexOf('/') - 1);
                    }
               }

            }

        }
        System.out.println("return:"+(fc.exists() && fc.isDirectory()));
        return (fc.exists() && fc.isDirectory());
    }

    public static String[] loadDiskDir(String path, boolean recr, int filtr) {
        System.err.println("mfw.loadDiskDir(" + path + ", " + recr + ", " +
                           filtr + ");");
        String[] ret = new String[0], rett = new String[0], temp = new String[0];
        String[] flt = null;
        if (filtr == NO_FILTER) {

        } else {
            if (filtr == ALL_ACSEPT) {
                flt = new String[15];
                flt[0] = ".wav";
                flt[1] = ".3gp";
                flt[2] = ".mp4";
                flt[3] = ".amr";
                flt[4] = ".mid";
                flt[5] = ".midi";
                flt[6] = ".wav";
                flt[7] = ".srt";
                flt[8] = ".imy";
                flt[9] = ".mfi";
                flt[10] = ".txt";
                flt[11] = ".ztxt";
                flt[12] = ".m3u";
                flt[14] = ".vpl";
                flt[13] = ".apl";
            } else if (filtr == AUDIO_FORMATS) {
                flt = new String[9];
                flt[0] = ".wav";
                flt[1] = ".3gp";
                flt[2] = ".amr";
                flt[3] = ".mid";
                flt[4] = ".midi";
                flt[5] = ".wav";
                flt[6] = ".srt";
                flt[7] = ".imy";
                flt[8] = ".mfi";
            } else if (filtr == VIDEO_FORMATS) {
                flt = new String[2];
                flt[0] = ".mp4";
                flt[1] = ".3gp";
            } else if (filtr == TEXT_FORMATS) {
                flt = new String[4];
                flt[0] = ".txt";
                flt[1] = ".mpt";
                flt[2] = ".mpz";
                flt[3] = ".tzt";
            } else if (filtr == PLL_FORMATS) {
                flt = new String[3];
                flt[0] = ".apl";
                flt[1] = ".vpl";
                flt[2] = ".m3u";
            } else if (filtr == FONT_FORMATS) {
                flt = new String[1];
                flt[0] = ".mhf";
            } else if (filtr == SKIN_FORMATS) {
                flt = new String[1];
                flt[0] = ".mhs";
            } else if (filtr == LNG_FORMATS) {
                flt = new String[1];
                flt[0] = ".mhl";
            } else if (filtr == NO_DIRS) {
                flt = new String[0];
            }

        }
        // LoadDir

        FileConnection conn = null;
        try {
            conn = (FileConnection) Connector.open("file:///" + path, 3);
            System.out.println(conn.getURL());
        } catch (IOException ex) {
            return null;
        }
        rett = new String[9999];
        int pnt = 0;
        if ((flt != null) || recr) {
            try {
                System.out.println("list point");
                Enumeration t = conn.list();
                while (t.hasMoreElements()) {
                    String tmp = (String) t.nextElement();
                    for (int i = 0; i < flt.length; i++) {
                        if ((tmp.toLowerCase().endsWith(flt[i])) &&
                            (!isDir(path + "/" + tmp))) {
                            rett[pnt] = path + "/" + tmp;
                            pnt++;
                            break;
                        }
                    }
                    System.out.println("recr point " + path + "/" + tmp);
                    conn.close();
                    conn = null;
                    conn = (FileConnection) Connector.open("file:///" + path +
                            "/" + tmp);
                    System.out.println(conn.getURL());
                    if (conn.isDirectory()) {
                        if (recr) {
                            temp = loadDiskDir(path + "/" + tmp, recr, filtr);
                            for (int i = 0; i < temp.length; i++) {
                                rett[pnt] = temp[i];
                                pnt++;
                                if (pnt >= 9999) {
                                    pnt = 0;
                                }
                            }
                        } else if (filtr == ALL_ACSEPT) {
                            rett[pnt] = path + "/" + tmp;
                            pnt++;
                        }
                    }
                    if (pnt >= 9999) {
                        pnt = 0;
                    }
                }
            } catch (IOException ex1) {
            }

        } else {
            try {
                Enumeration t = conn.list();
                while (t.hasMoreElements()) {
                    rett[pnt] = (String) t.nextElement();
                    rett[pnt] = path + "/" + rett[pnt];
                    pnt++;
                    if (pnt >= 9999) {
                        pnt = 0;
                    }
                }
            } catch (IOException ex1) {
            }

        }
        ret = new String[pnt];
        for (int i = 0; i < ret.length; i++) {
            ret[i] = rett[i];
        }
        try {
            conn.close();
        } catch (IOException ex2) {
        }
        return ret;
    }

/*    Load Disk Dir
    public static String[] loadDiskDir(String path, boolean recr, boolean dir, String[] flt) {
        String[] ret = new String[0], rett = new String[0], temp = new String[0];
        // LoadDir
        FileConnection conn = null;
        try {
            conn = (FileConnection) Connector.open("file:///" + path, 3);
            System.out.println(conn.getURL());
        } catch (IOException ex) {
            return null;
        }
        rett = new String[9999];
        int pnt = 0;
        if ((flt != null) || recr) {
            try {
                System.out.println("list point");
                Enumeration t = conn.list();
                while (t.hasMoreElements()) {
                    String tmp = (String) t.nextElement();
                    for (int i = 0; i < flt.length; i++) {
                        if ((tmp.toLowerCase().endsWith(flt[i])) &&
                            (!isDir(path + "/" + tmp))) {
                            rett[pnt] = path + "/" + tmp;
                            pnt++;
                            break;
                        }
                    }
                    System.out.println("recr point " + path + "/" + tmp);
                    conn.close();
                    conn = null;
                    conn = (FileConnection) Connector.open("file:///" + path +
                            "/" + tmp);
                    System.out.println(conn.getURL());
                    if (conn.isDirectory()) {
                        if (recr) {
                            temp = loadDiskDir(path + "/" + tmp, recr, dir, flt);
                            for (int i = 0; i < temp.length; i++) {
                                rett[pnt] = temp[i];
                                pnt++;
                                if (pnt >= 9999) {
                                    pnt = 0;
                                }
                            }
                        } else if (dir) {
                            rett[pnt] = path + "/" + tmp;
                            pnt++;
                        }
                    }
                    if (pnt >= 9999) {
                        pnt = 0;
                    }
                }
            } catch (IOException ex1) {
            }

        } else {
            try {
                Enumeration t = conn.list();
                while (t.hasMoreElements()) {
                    rett[pnt] = (String) t.nextElement();
                    rett[pnt] = path + "/" + rett[pnt];
                    pnt++;
                    if (pnt >= 9999) {
                        pnt = 0;
                    }
                }
            } catch (IOException ex1) {
            }

        }
        ret = new String[pnt];
        for (int i = 0; i < ret.length; i++) {
            ret[i] = rett[i];
        }
        try {
            conn.close();
        } catch (IOException ex2) {
        }
        return ret;
    }
*/

    private void jbInit() throws Exception {
    }
}
